repa-3.2.3.3: High performance, regular, shape polymorphic parallel arrays.

Safe Haskell | None

Data.Array.Repa.Slice

Description

Index space transformation between arrays and slices.

Synopsis

- data All = All
- data Any sh = Any
- type family FullShape ss
- type family SliceShape ss
- class Slice ss where
  - sliceOfFull :: ss -> FullShape ss -> SliceShape ss
  - fullOfSlice :: ss -> SliceShape ss -> FullShape ss

# Documentation

data All Source

Select all indices at a certain position.

Constructors

All |

Instances

Slice sl => Slice (:. sl All) |

data Any sh Source

Place holder for any possible shape.

Constructors

Any |

Instances

Slice (Any sh) |

type family FullShape ss Source

Map a type of the index in the full shape, to the type of the index in the slice.

type family SliceShape ss Source

Map the type of an index in the slice, to the type of the index in the full shape.

class Slice ss where Source

Class of index types that can map to slices.

Methods

sliceOfFull :: ss -> FullShape ss -> SliceShape ssSource

Map an index of a full shape onto an index of some slice.

fullOfSlice :: ss -> SliceShape ss -> FullShape ssSource

Map an index of a slice onto an index of the full shape.

Instances

Slice Z |
Slice (Any sh) |
Slice sl => Slice (:. sl All) |
Slice sl => Slice (:. sl Int) |